//[File]            : WOX_mcu_cfg_hs.h
//[Revision time]   : Fri Jul 30 12:22:26 2021
//[Description]     : This file is auto generated by CODA
//[Copyright]       : Copyright (C) 2021 Mediatek Incorportion. All rights reserved.

#ifndef __WOX_MCU_CFG_HS_REGS_H__
#define __WOX_MCU_CFG_HS_REGS_H__


//****************************************************************************
//
//                     WOX_MCU_CFG_HS CR Definitions                     
//
//****************************************************************************

#define WOX_MCU_CFG_HS_BASE                                    0 /* 0x15195000 */

#define WOX_MCU_CFG_HS_WOX_APSRC_ADDR                          (WOX_MCU_CFG_HS_BASE + 0x0070) // 5070
#define WOX_MCU_CFG_HS_MCSR_ADDR                               (WOX_MCU_CFG_HS_BASE + 0x010C) // 510C
#define WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR                         (WOX_MCU_CFG_HS_BASE + 0x029C) // 529C




/* =====================================================================================

  ---WOX_APSRC (0x15195000 + 0x0070)---

    WOX_APSRC_IDLE[0]            - (RW) WOX APSRC idle
    WOX_APSRC_REQ[1]             - (RW) WOX APSRC request
    WOX_APSRC_POWOFF[2]          - (RW) WOX APSRC power off
    WOX_APSRC_DDREN[3]           - (RW) WOX APSRC DDREN
    RESERVED4[31..4]             - (RO) Reserved bits

 =====================================================================================*/
#define WOX_MCU_CFG_HS_WOX_APSRC_WOX_APSRC_DDREN_ADDR          WOX_MCU_CFG_HS_WOX_APSRC_ADDR
#define WOX_MCU_CFG_HS_WOX_APSRC_WOX_APSRC_DDREN_MASK          0x00000008                // WOX_APSRC_DDREN[3]
#define WOX_MCU_CFG_HS_WOX_APSRC_WOX_APSRC_DDREN_SHFT          3
#define WOX_MCU_CFG_HS_WOX_APSRC_WOX_APSRC_POWOFF_ADDR         WOX_MCU_CFG_HS_WOX_APSRC_ADDR
#define WOX_MCU_CFG_HS_WOX_APSRC_WOX_APSRC_POWOFF_MASK         0x00000004                // WOX_APSRC_POWOFF[2]
#define WOX_MCU_CFG_HS_WOX_APSRC_WOX_APSRC_POWOFF_SHFT         2
#define WOX_MCU_CFG_HS_WOX_APSRC_WOX_APSRC_REQ_ADDR            WOX_MCU_CFG_HS_WOX_APSRC_ADDR
#define WOX_MCU_CFG_HS_WOX_APSRC_WOX_APSRC_REQ_MASK            0x00000002                // WOX_APSRC_REQ[1]
#define WOX_MCU_CFG_HS_WOX_APSRC_WOX_APSRC_REQ_SHFT            1
#define WOX_MCU_CFG_HS_WOX_APSRC_WOX_APSRC_IDLE_ADDR           WOX_MCU_CFG_HS_WOX_APSRC_ADDR
#define WOX_MCU_CFG_HS_WOX_APSRC_WOX_APSRC_IDLE_MASK           0x00000001                // WOX_APSRC_IDLE[0]
#define WOX_MCU_CFG_HS_WOX_APSRC_WOX_APSRC_IDLE_SHFT           0

/* =====================================================================================

  ---MCSR (0x15195000 + 0x010C)---

    RESERVED0[19..0]             - (RO) Reserved bits
    STBY2RESUM_CYC[24..20]       - (RW) Standby to Resume Cycle Setting
    RESERVED25[31..25]           - (RO) Reserved bits

 =====================================================================================*/
#define WOX_MCU_CFG_HS_MCSR_STBY2RESUM_CYC_ADDR                WOX_MCU_CFG_HS_MCSR_ADDR
#define WOX_MCU_CFG_HS_MCSR_STBY2RESUM_CYC_MASK                0x01F00000                // STBY2RESUM_CYC[24..20]
#define WOX_MCU_CFG_HS_MCSR_STBY2RESUM_CYC_SHFT                20

/* =====================================================================================

  ---WOX_MCU_CG (0x15195000 + 0x029C)---

    WOXCPU_GT_CKEN[0]            - (RW)  xxx 
    WOXULM_CLK_EN2[1]            - (RW)  xxx 
    BUS_CLK_EN2[2]               - (RW)  xxx 
    AXI_CLK_EN[3]                - (RW)  xxx 
    CPU2AXI_BUS_DIV_EN[4]        - (RW)  xxx 
    AXI2LS_BUS_DIV_EN[5]         - (RW)  xxx 
    AXI_GT_CKEN[6]               - (RW)  xxx 
    AXI_DIVFR_CKEN[7]            - (RW)  xxx 
    RESERVED8[10..8]             - (RO) Reserved bits
    MCUSYS_CLK_EN[11]            - (RW)  xxx 
    RESERVED12[12]               - (RO) Reserved bits
    CFG_HS_PCLK_GT_EN[13]        - (RW)  xxx 
    EXCP_CON_PCLK_GT_EN[14]      - (RW)  xxx 
    AXIMON_PCLK_GT_EN[15]        - (RW)  xxx 
    WO1CPU_GT_CKEN[16]           - (WO)  xxx 
    WO1ULM_CLK_EN2[17]           - (WO)  xxx 
    RESERVED18[31..18]           - (RO) Reserved bits

 =====================================================================================*/
#define WOX_MCU_CFG_HS_WOX_MCU_CG_WO1ULM_CLK_EN2_ADDR          WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_WO1ULM_CLK_EN2_MASK          0x00020000                // WO1ULM_CLK_EN2[17]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_WO1ULM_CLK_EN2_SHFT          17
#define WOX_MCU_CFG_HS_WOX_MCU_CG_WO1CPU_GT_CKEN_ADDR          WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_WO1CPU_GT_CKEN_MASK          0x00010000                // WO1CPU_GT_CKEN[16]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_WO1CPU_GT_CKEN_SHFT          16
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXIMON_PCLK_GT_EN_ADDR       WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXIMON_PCLK_GT_EN_MASK       0x00008000                // AXIMON_PCLK_GT_EN[15]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXIMON_PCLK_GT_EN_SHFT       15
#define WOX_MCU_CFG_HS_WOX_MCU_CG_EXCP_CON_PCLK_GT_EN_ADDR     WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_EXCP_CON_PCLK_GT_EN_MASK     0x00004000                // EXCP_CON_PCLK_GT_EN[14]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_EXCP_CON_PCLK_GT_EN_SHFT     14
#define WOX_MCU_CFG_HS_WOX_MCU_CG_CFG_HS_PCLK_GT_EN_ADDR       WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_CFG_HS_PCLK_GT_EN_MASK       0x00002000                // CFG_HS_PCLK_GT_EN[13]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_CFG_HS_PCLK_GT_EN_SHFT       13
#define WOX_MCU_CFG_HS_WOX_MCU_CG_MCUSYS_CLK_EN_ADDR           WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_MCUSYS_CLK_EN_MASK           0x00000800                // MCUSYS_CLK_EN[11]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_MCUSYS_CLK_EN_SHFT           11
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXI_DIVFR_CKEN_ADDR          WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXI_DIVFR_CKEN_MASK          0x00000080                // AXI_DIVFR_CKEN[7]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXI_DIVFR_CKEN_SHFT          7
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXI_GT_CKEN_ADDR             WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXI_GT_CKEN_MASK             0x00000040                // AXI_GT_CKEN[6]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXI_GT_CKEN_SHFT             6
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXI2LS_BUS_DIV_EN_ADDR       WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXI2LS_BUS_DIV_EN_MASK       0x00000020                // AXI2LS_BUS_DIV_EN[5]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXI2LS_BUS_DIV_EN_SHFT       5
#define WOX_MCU_CFG_HS_WOX_MCU_CG_CPU2AXI_BUS_DIV_EN_ADDR      WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_CPU2AXI_BUS_DIV_EN_MASK      0x00000010                // CPU2AXI_BUS_DIV_EN[4]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_CPU2AXI_BUS_DIV_EN_SHFT      4
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXI_CLK_EN_ADDR              WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXI_CLK_EN_MASK              0x00000008                // AXI_CLK_EN[3]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_AXI_CLK_EN_SHFT              3
#define WOX_MCU_CFG_HS_WOX_MCU_CG_BUS_CLK_EN2_ADDR             WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_BUS_CLK_EN2_MASK             0x00000004                // BUS_CLK_EN2[2]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_BUS_CLK_EN2_SHFT             2
#define WOX_MCU_CFG_HS_WOX_MCU_CG_WOXULM_CLK_EN2_ADDR          WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_WOXULM_CLK_EN2_MASK          0x00000002                // WOXULM_CLK_EN2[1]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_WOXULM_CLK_EN2_SHFT          1
#define WOX_MCU_CFG_HS_WOX_MCU_CG_WOXCPU_GT_CKEN_ADDR          WOX_MCU_CFG_HS_WOX_MCU_CG_ADDR
#define WOX_MCU_CFG_HS_WOX_MCU_CG_WOXCPU_GT_CKEN_MASK          0x00000001                // WOXCPU_GT_CKEN[0]
#define WOX_MCU_CFG_HS_WOX_MCU_CG_WOXCPU_GT_CKEN_SHFT          0

#ifdef __cplusplus
}
#endif

#endif // __WOX_MCU_CFG_HS_REGS_H__
